Lattice Grid Buy a licence

demo D132

prefers-reduced-motion

Every animation the grid drops when the viewer asks for less

@media (prefers-reduced-motion: reduce)

Building…
Loading a live grid…

The configuration

import * as ng from '@angular/core';
import { Component } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { createGrid } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import createLatticeGrid from '@toclocoinc/lattice-grid/modules/angular';

const { LatticeGridComponent } = createLatticeGrid({ ng, createGrid });

// True when the viewer has asked for less motion, right now. The reading is
// taken once, when the grid is built; change the preference in your OS, then
// reload.
function reducedMotionNow() {
  return typeof matchMedia === 'function'
    && matchMedia('(prefers-reduced-motion: reduce)').matches;
}

const columns = [
  { field: 'part', title: 'What moves', layout: { width: 210, pin: 'start' } },
  { field: 'selector', title: 'Selector', layout: { width: 300 } },
  { field: 'normally', title: 'Normally', layout: { width: 280 }, cell: { wrap: true } },
  { field: 'reduced', title: 'Under reduce', layout: { flex: 1, min: 260 }, cell: { wrap: true } },
  {
    id: 'now', title: 'Right now', layout: { width: 150 },
    // Depends on the viewer's OS setting, which is not in the row, so it must
    // never be materialised into the store as though it were data.
    sort: false, filter: false,
    value: {
      pure: false, deps: '*',
      compute: (_deps, ctx) => {
        if (!ctx?.data?.covered) return 'still plays';
        return reducedMotionNow() ? 'dropped' : 'plays';
      },
    },
    cell: { decoration: 'pill', variant: { map: { dropped: 'success', plays: 'info', 'still plays': 'neutral' } } },
  },
];

const rows = [/* one row per animated part: selector, normal and reduced behaviour, covered */];



@Component({
  selector: 'app-root',
  standalone: true,
  imports: [LatticeGridComponent],
  template: '<lattice-grid [config]="grid" style="display:block;height:540px"></lattice-grid>',
})
export class AppComponent {
  grid = {
    rowKey: 'id',
    autoHeight: true,
    columns: columns,
    rows: rows,
  };
}

bootstrapApplication(AppComponent);

Respecting prefers-reduced-motion in a data grid

Reduced motion support means the grid checks the operating system’s motion preference and drops non-essential animation when the viewer has asked for it. Lattice Grid does this automatically through the @media (prefers-reduced-motion: reduce) query rather than a grid-level flag, so row reordering, column resize easing, sort transitions and the hover shimmer on active cells all switch to instant state changes the moment the setting is on, with no configuration needed in the page that hosts the grid. A developer reaches for this when the grid sits inside a product that already honours the preference elsewhere, or when a user has reported nausea or disorientation from scrolling and reflow animation, which is the documented effect the media query exists to prevent under WCAG 2.3.3. Vestibular disorders are the usual driver behind the operating-system setting, and a JavaScript data grid that ignores it forces those users to either tolerate the motion or avoid the page. Because the check runs at the CSS layer rather than in per-interaction JavaScript, there is no extra render cost when the preference is off: the animation rules do not apply, and the grid’s virtual scrolling continues to recycle rows at the same rate regardless of which state the media query is in.

Does Lattice Grid support prefers-reduced-motion?

Yes. The grid listens for the @media (prefers-reduced-motion: reduce) query and removes transition and easing effects on row moves, resizes, sorts and hover states when it matches, without a separate configuration option. Turning on reduced motion at the operating-system level is enough; no grid-specific setting is required to make the change take effect.

Lattice Grid Buy a licence

demo D132

prefers-reduced-motion

Every animation the grid drops when the viewer asks for less

@media (prefers-reduced-motion: reduce)

Building…
Loading a live grid…

The configuration

<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.min.css">

<div id="grid"></div>

<script type="module">
  import React from 'https://esm.sh/react@18';
  import { createRoot } from 'https://esm.sh/react-dom@18/client';
  import { createGrid } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.esm.min.js';
  import createLatticeGrid from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/modules/react.esm.min.js';

  const LatticeGrid = createLatticeGrid({ React, createGrid });

  // True when the viewer has asked for less motion, right now. The reading is
  // taken once, when the grid is built; change the preference in your OS, then
  // reload.
  function reducedMotionNow() {
    return typeof matchMedia === 'function'
      && matchMedia('(prefers-reduced-motion: reduce)').matches;
  }

  const columns = [
    { field: 'part', title: 'What moves', layout: { width: 210, pin: 'start' } },
    { field: 'selector', title: 'Selector', layout: { width: 300 } },
    { field: 'normally', title: 'Normally', layout: { width: 280 }, cell: { wrap: true } },
    { field: 'reduced', title: 'Under reduce', layout: { flex: 1, min: 260 }, cell: { wrap: true } },
    {
      id: 'now', title: 'Right now', layout: { width: 150 },
      // Depends on the viewer's OS setting, which is not in the row, so it must
      // never be materialised into the store as though it were data.
      sort: false, filter: false,
      value: {
        pure: false, deps: '*',
        compute: (_deps, ctx) => {
          if (!ctx?.data?.covered) return 'still plays';
          return reducedMotionNow() ? 'dropped' : 'plays';
        },
      },
      cell: { decoration: 'pill', variant: { map: { dropped: 'success', plays: 'info', 'still plays': 'neutral' } } },
    },
  ];

  const rows = [/* one row per animated part: selector, normal and reduced behaviour, covered */];

  function App() {
    return (
      <LatticeGrid
        rowKey="id"
        autoHeight
        columns={columns}
        rows={rows}
        style={{ width: '100%' }}
      />
    );
  }

  createRoot(document.getElementById('grid')).render(<App />);
</script>

Respecting prefers-reduced-motion in a data grid

Reduced motion support means the grid checks the operating system’s motion preference and drops non-essential animation when the viewer has asked for it. Lattice Grid does this automatically through the @media (prefers-reduced-motion: reduce) query rather than a grid-level flag, so row reordering, column resize easing, sort transitions and the hover shimmer on active cells all switch to instant state changes the moment the setting is on, with no configuration needed in the page that hosts the grid. A developer reaches for this when the grid sits inside a product that already honours the preference elsewhere, or when a user has reported nausea or disorientation from scrolling and reflow animation, which is the documented effect the media query exists to prevent under WCAG 2.3.3. Vestibular disorders are the usual driver behind the operating-system setting, and a JavaScript data grid that ignores it forces those users to either tolerate the motion or avoid the page. Because the check runs at the CSS layer rather than in per-interaction JavaScript, there is no extra render cost when the preference is off: the animation rules do not apply, and the grid’s virtual scrolling continues to recycle rows at the same rate regardless of which state the media query is in.

Does Lattice Grid support prefers-reduced-motion?

Yes. The grid listens for the @media (prefers-reduced-motion: reduce) query and removes transition and easing effects on row moves, resizes, sorts and hover states when it matches, without a separate configuration option. Turning on reduced motion at the operating-system level is enough; no grid-specific setting is required to make the change take effect.